#include <dht.h>
#include <Wire.h>
#include <BMP180.h>
#include <SoftwareSerial.h>

SoftwareSerial BT(10, 11); 
dht DHT;
BMP180 barometer; //Die Instanzvariable eines BMP180 Sensors.
int sensorPin = 13; //PWM PIN des DHT11 Sensors

void setup(){
  BT.begin(9600);                    // Setzen der Baudrate für die Koomunikation über Bluetooth
  BT.println("Hello from Arduino");  // Setzen der Willkommensnachricht wenn sich ein Client verbindet.
   Serial.begin(115200);
  Wire.begin(); //Adafruit Wire Bibliothek für die I2C Kommunikation mit dem BMP180 Sensor.
  barometer = BMP180(); //setzen einer Instanz des BMP180 Sensors.
}

char a; // Variable zum speichern des gelesenen Wertes.

void loop(){
   int chk = DHT.read11(sensorPin); //Status holen
  if (BT.available()){         // Wenn Bluetooth verfügbar ist dann...
    Serial.println("BT.available()");
    a=(BT.read());             // lesen vom Seriellen Port des Bluetooth Moduls
    Serial.println(a);
    if (a=='t'){               // 't' für Temperatur
      BT.println(getTemperatur());
    } else if (a=='h'){        // 'h' für Luftfeuchtigkeit
      BT.println(getLuftfeuchtigkeit());
    } else if (a=='p'){        // 'p' für Luftdruck
      BT.println(getLuftdruck());
    } else {                   // Wenn nicht 't', 'h', oder 'p' empfangen wurde, soll folgende Beschreibung des Dienstes ausgegeben werden.
      BT.println("Bluetooth - Wetterstation");
      BT.println("*************************");
      BT.println("[t] Temperatur");
      BT.println("[h] Luftfeuchtigkeit");
      BT.println("[p] Luftdruck");
    }   
  }
}

//Liefert den Wert für die Temperatur aus dem DHT11 Sensor
String getTemperatur(){
 return "Temperatur - "+ String(DHT.temperature,1) + "C";  
}

//Liefert den Wert für die Luftfeuchtigkeit aus dem DHT11 Sensor
String getLuftfeuchtigkeit(){
 return "Luftfeuchtigkeit - "+ String(DHT.humidity,1) +"%";  
}

//Liefert den Wert für den Luftdruck aus dem BMP180 Sensor
String getLuftdruck(){
  long currentPressure = barometer.GetPressure();
  String pressure = "Luftdruck - "+ String(currentPressure / 100) + " hPa";
  return pressure;  
}


